# https://github.com/fail2ban/fail2ban/archive/0.10.3.1.tar.gz

Name:		          fail2ban
Version:	        0.10.3.1
Release:	        %mkrel 1
Summary:	        Ban hosts that cause multiple authentication errors

License:	        GPLv2+
Group:		        System/Configuration/Networking
URL:		          http://www.fail2ban.org/
Source0:	        %{name}-%{version}.tar.xz
Source1:	        %{name}-initscript
Source2:	        paths-uplos.conf
Patch0:           %{name}-0.10.0-uplos-paths.patch
Patch1:		        %{name}-0.10.3.1-log-actions-to-SYSLOG.patch
#Patch2:           %{name}-0.10.3.1-fix-version.patch

BuildArch:        noarch
BuildRequires:    python3-coverage
BuildRequires:	  python3-devel
BuildRequires:    python3-setuptools
Requires(post):   rpm-helper
Requires(preun):  rpm-helper
Requires:	        iptables >= 1.3.5
Requires:	        python3 >= %{python3_version}
Requires:	        tcp_wrappers >= 7.6-29

%description
Fail2Ban scans log files like /var/log/auth.log and bans IP addresses having
too many failed login attempts. It does this by updating system firewall
rules to reject new connections from those IP addresses, for a configurable
amount of time. Fail2Ban comes out-of-the-box ready to read many standard
log files, such as those for sshd and Apache, and is easy to configure
to read any log file you choose, for any error you choose.

%package          tests
Summary:	        Fail2Ban testcases
Group:            System/Configuration/Networking
Requires:	        %{name} = %{version}-%{release}

%description      tests
Package provides testscases and scripts for %{name}.

%prep
%setup -q
%apply_patches

%build
./fail2ban-2to3
find -type f -iname \*.bak -delete
%py3_build

%install
%py3_install
%py_byte_compile %{__python3} %{buildroot}%{python3_sitelib}
%__install -Dm644 files/bash-completion %{buildroot}%{_datadir}/bash-completion/completions/%{name}
%__install -d %{buildroot}%{_mandir}/man{1,5}
%__install -m644 man/*.1 %{buildroot}%{_mandir}/man1/
%__install -m644 man/jail.conf.5 %{buildroot}%{_mandir}/man5/
%__install -Dm744 %{S:1} %{buildroot}%{_initrddir}/%{name}
%__install -m644 %{S:2} %{buildroot}%{_sysconfdir}/%{name}/paths-uplos.conf
%__install -dm755 %{buildroot}%{_var}/lib/%{name}
%__install -dm755 %{buildroot}%{_var}/run/%{name}
%__rm -rf %{buildroot}%{_docdir}/%{name}

%check
%__cp -vf %{S:2} config/
export LANG=en_US.UTF-8
./fail2ban-testcases-all-python3 -f --no-network

%pre
if [ $1 -gt 1 ] ; then
%__service %{name} stop &>/dev/null
fi

%post
%_post_service %{name}
%__service %{name} start

%preun
%_preun_service %{name}

%files
%defattr(-,root,root)
%doc ChangeLog FILTERS README.md doc/run-rootless.txt
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/*.conf
%dir %{_sysconfdir}/%{name}/action.d/
%config(noreplace) %{_sysconfdir}/%{name}/action.d/*.conf
%{_sysconfdir}/%{name}/action.d/*.py
%dir %{_sysconfdir}/%{name}/filter.d/
%dir %{_sysconfdir}/%{name}/filter.d/ignorecommands
%config(noreplace) %{_sysconfdir}/%{name}/filter.d/*.conf
%{_sysconfdir}/%{name}/filter.d/ignorecommands/apache-fakegooglebot
%dir %{_sysconfdir}/%{name}/jail.d
%attr(744,root,root) %{_initrddir}/%{name}
%{_bindir}/%{name}-*
%{python3_sitelib}/%{name}
%{python3_sitelib}/%{name}-0.10.3.fix1-py%{python3_version}.egg-info
%{_datadir}/bash-completion/completions/%{name}
%{_mandir}/man1/%{name}*.bz2
%{_mandir}/man5/jail.conf.5.bz2
%dir %{_var}/lib/%{name}
%dir %{_var}/run/%{name}
%exclude %{_bindir}/%{name}-testcases
%exclude %{python3_sitelib}/%{name}/tests
%exclude %{_mandir}/man1/%{name}-testcases.1.bz2

%files tests
%defattr(-,root,root)
%doc DEVELOP
%{_bindir}/%{name}-testcases
%{python3_sitelib}/%{name}/tests
%{_mandir}/man1/%{name}-testcases.1.bz2

%changelog
* Mon Oct 29 2018 adrianomorselli <adrianomorselli> 0.10.3.1-1uplos2018
- update, switched to python3
- temporarily added %%pre scriplet and 2nd line of %%post for smoothly
  transition to python3
- enabled bash completion and byte compiling
